<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "directory_base_component_template_section".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DirectoryBaseComponentTemplateSection".
 *
 * Columns in table "directory_base_component_template_section" available as properties of the model,
 * followed by relations of table "directory_base_component_template_section" available as properties of the model.
 *
 * @property integer $id
 * @property integer $base_component_template_id
 * @property integer $component_section_id
 *
 * @property DirectoryBaseComponentTemplate $baseComponentTemplate
 * @property DirectoryComponentSection $componentSection
 */
abstract class BaseDirectoryBaseComponentTemplateSection extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'directory_base_component_template_section';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DirectoryBaseComponentTemplateSection|DirectoryBaseComponentTemplateSections', $n);
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('base_component_template_id, component_section_id', 'required'),
            array('base_component_template_id, component_section_id', 'numerical', 'integerOnly' => true),
            array('id, base_component_template_id, component_section_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'baseComponentTemplate' => array(self::BELONGS_TO, 'DirectoryBaseComponentTemplate', 'base_component_template_id'),
            'componentSection' => array(self::BELONGS_TO, 'DirectoryComponentSection', 'component_section_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'base_component_template_id' => null,
            'component_section_id' => null,
            'baseComponentTemplate' => null,
            'componentSection' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('base_component_template_id', $this->base_component_template_id);
        $criteria->compare('component_section_id', $this->component_section_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }
}
